unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus;

const
  PCR0 = $20;
  CCR1 = $C1;
  CCR2 = $C2;
  CCR3 = $C3;
  CCR4 = $E8;
  SMAR0 = $CD;
  SMAR1 = $CE;
  SMAR2 = $CF;
  PMR = $F0;
  DIR0 = $FE;
  DIR1 = $FF;

type
  TfrmMain = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtDevice: TEdit;
    Label2: TLabel;
    txtStepping: TEdit;
    Label3: TLabel;
    txtRevision: TEdit;
    Label4: TLabel;
    txtClock: TEdit;
    GroupBox2: TGroupBox;
    chkSMAC: TCheckBox;
    chkUSE_SMI: TCheckBox;
    chkMMAC: TCheckBox;
    GroupBox3: TGroupBox;
    chkLOCK_NW: TCheckBox;
    chkUSE_WBAK: TCheckBox;
    chkSUSP_HALT: TCheckBox;
    chkWT1: TCheckBox;
    chkBWRT: TCheckBox;
    chkUSE_SUSP: TCheckBox;
    GroupBox4: TGroupBox;
    chkNMI_EN: TCheckBox;
    chkSMI_LOCK: TCheckBox;
    chkLINBRST: TCheckBox;
    chkSMM_MODE: TCheckBox;
    btnExit: TButton;
    btnAdvanced: TButton;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    About1: TMenuItem;
    btnRefresh: TButton;
    btnUpdate: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnAdvancedClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowRegisters;
  end;

function ReadRegister(num: Byte): Byte;
procedure WriteRegister(num, value: Byte);
procedure PrepareRegisters;
procedure UpdateRegisters;

var
  frmMain: TfrmMain;
  PCR0_value: Byte;
  CCR4_value: Byte;
  PMR_value: Byte;

implementation

{$R *.DFM}

uses Advanced, Msg, About;

var
  DeviceID: Byte;
  StepID: Byte;
  RevisionID: Byte;
  CCR1_value: Byte;
  CCR2_value: Byte;
  CCR3_value: Byte;

function isCyrix: Boolean; assembler;
asm
   XOR   AX,AX
   SAHF
   MOV   AX,5
   MOV   BX,2
   DIV   BL
   LAHF
   CMP   AH,2
   JNE   @@1
   MOV   AL,1
   JMP   @@2
@@1:
   XOR   AL,AL
@@2:
end;

function ReadRegister; assembler;
asm
   MOV   AL,num
   OUT   22H,AL
   IN    AL,23H
end;

procedure WriteRegister; assembler;
asm
   CLI
   MOV    AL,num
   OUT    22H,AL
   MOV    AL,value
   OUT    23H,AL
   STI
end;

procedure PrepareRegisters;
begin
  CCR1_value := 0;
  CCR2_value := 0;
  CCR3_value := 0;
  CCR4_value := 0;
  PCR0_value := 0;
  PMR_value := 0;
  with frmMain do begin
    if chkUSE_SMI.state = cbChecked then
      CCR1_value := CCR1_value or $2;
    if chkSMAC.state = cbChecked then
      CCR1_value := CCR1_value or $4;
    if chkMMAC.state = cbChecked then
      CCR1_value := CCR1_value or $8;
    if chkUSE_WBAK.state = cbChecked then
      CCR2_value := CCR2_value or $2;
    if chkLOCK_NW.state = cbChecked then
      CCR2_value := CCR2_value or $4;
    if chkSUSP_HALT.state = cbChecked then
      CCR2_value := CCR2_value or $8;
    if chkWT1.state = cbChecked then
      CCR2_value := CCR2_value or $10;
    if chkBWRT.state = cbChecked then
      CCR2_value := CCR2_value or $40;
    if chkUSE_SUSP.state = cbChecked then
      CCR2_value := CCR2_value or $80;
    if chkSMI_LOCK.state = cbChecked then
      CCR3_value := CCR3_value or $1;
    if chkNMI_EN.state = cbChecked then
      CCR3_value := CCR3_value or $2;
    if chkLINBRST.state = cbChecked then
      CCR3_value := CCR3_value or $4;
    if chkSMM_MODE.state = cbChecked then
      CCR3_value := CCR3_value or $8
  end;
  with frmAdvanced do begin
    if chkRSTK_EN.state = cbChecked then
      PCR0_value := PCR0_value or $1;
    if chkBTB_EN.state = cbChecked then
      PCR0_value := PCR0_value or $2;
    if chkLOOP_EN.state = cbChecked then
      PCR0_value := PCR0_value or $4;
    if chkLSSER.state = cbChecked then
      PCR0_value := PCR0_value or $80;
    CCR4_value := radIORT.ItemIndex;
    if chkMEM_BYP.state = cbChecked then
      CCR4_value := CCR4_value or $8;
    if chkDTE_EN.state = cbChecked then
      CCR4_value := CCR4_value or $10;
    if chkFAST_FPU.state = cbChecked then
      CCR4_value := CCR4_value or $20;
    PMR_value := radCLK.ItemIndex;
    if chkHLF_CLK.state = cbChecked then
      PMR_value := PMR_value or $4
  end
end;

procedure UpdateRegisters;
var
  result: boolean;
  value, app, key, name: PChar;
begin
  WriteRegister(CCR1, CCR1_value);
  WriteRegister(CCR2, CCR2_value);
  WriteRegister(CCR3, CCR3_value or $10);
  WriteRegister(PCR0, PCR0_value);
  WriteRegister(CCR4, CCR4_value);
  WriteRegister(PMR, PMR_value);
  WriteRegister(CCR3, CCR3_value);
asm
   DB     0FH,08H     { INVD }
   JMP    @@1
@@1:
end;
  { Write Configuration register value into profile }
  GetMem(value, 256);
  GetMem(app, 256);
  GetMem(key, 256);
  GetMem(name, 256);
  StrPCopy(app, 'CONFIG');
  StrPCopy(name, 'CYRIX.INI');
  StrPCopy(key, 'CCR1');
  StrPCopy(value, IntToStr(CCR1_value));
  result := WritePrivateProfileString(app, key, value, name);
  StrPCopy(key, 'CCR2');
  StrPCopy(value, IntToStr(CCR2_value));
  result := WritePrivateProfileString(app, key, value, name);
  StrPCopy(key, 'CCR3');
  StrPCopy(value, IntToStr(CCR3_value));
  result := WritePrivateProfileString(app, key, value, name);
  StrPCopy(key, 'CCR4');
  StrPCopy(value, IntToStr(CCR4_value));
  result := WritePrivateProfileString(app, key, value, name);
  StrPCopy(key, 'PCR0');
  StrPCopy(value, IntToStr(PCR0_value));
  result := WritePrivateProfileString(app, key, value, name);
  StrPCopy(key, 'PMR');
  StrPCopy(value, IntToStr(PMR_value));
  result := WritePrivateProfileString(app, key, value, name);
  FreeMem(name, 256);
  FreeMem(key, 256);
  FreeMem(app, 256);
  FreeMem(value, 256)
end;

procedure TfrmMain.ShowRegisters;
var
  DIR1_value: BYTE;
  result: WORD;
  app, key, name: PChar;
begin
  { Read Device ID, Stepping ID and Revision ID }
  DIR1_value := ReadRegister(DIR1);
  StepID := (DIR1_value and $f0) shr 4;
  RevisionID := DIR1_value and $f;
  txtDevice.Text := IntToHEX(DeviceID, 2);
  txtStepping.Text := IntToHEX(StepID, 2);
  txtRevision.Text := IntToHEX(RevisionID, 2);
  if (DeviceID = $29) or (DeviceID = $2B) then
    txtClock.Text := 'Double clock'
  else if (DeviceID = $2D) or (DeviceID = $2F) then
    txtClock.Text := 'Tripple clock'
  else
    txtClock.Text := 'Unknown';

  { Read Configuration Registers including PCR0, CCR4 and PMR }
  CCR1_value := ReadRegister(CCR1);
  CCR2_value := ReadRegister(CCR2);
  CCR3_value := ReadRegister(CCR3);
  WriteRegister(CCR3, CCR3_value or $10);
  PCR0_value := ReadRegister(PCR0);
  CCR4_value := ReadRegister(CCR4);
  PMR_value := ReadRegister(PMR);
  WriteRegister(CCR3, CCR3_value);

  { Read Configuration Registers from profile }
  GetMem(app, 256);
  GetMem(key, 256);
  GetMem(name, 256);
  StrPCopy(app, 'CONFIG');
  StrPCopy(name, 'CYRIX.INI');
  StrPCopy(key, 'CCR1');
  result := GetPrivateProfileInt(app, key, 32767, name);
  if (result <> 32767) then begin
    CCR1_value := result;
    StrPCopy(key, 'CCR2');
    CCR2_value := GetPrivateProfileInt(app, key, 32767, name);
    StrPCopy(key, 'CCR3');
    CCR3_value := GetPrivateProfileInt(app, key, 32767, name);
    StrPCopy(key, 'CCR4');
    CCR4_value := GetPrivateProfileInt(app, key, 32767, name);
    StrPCopy(key, 'PCR0');
    PCR0_value := GetPrivateProfileInt(app, key, 32767, name);
    StrPCopy(key, 'PMR');
    PMR_value := GetPrivateProfileInt(app, key, 32767, name);
    UpdateRegisters
  end;

  if (CCR1_value and $2 = 0) then
    chkUSE_SMI.state := cbUnchecked
  else
    chkUSE_SMI.state := cbChecked;
  if (CCR1_value and $4 = 0) then
    chkSMAC.state := cbUnchecked
  else
    chkSMAC.state := cbChecked;
  if (CCR1_value and $8 = 0) then
    chkMMAC.state := cbUnchecked
  else
    chkMMAC.state := cbChecked;

  if (CCR2_value and $2 = 0) then
    chkUSE_WBAK.state := cbUnchecked
  else
    chkUSE_WBAK.state := cbChecked;
  if (CCR2_value and $4 = 0) then
    chkLOCK_NW.state := cbUnchecked
  else
    chkLOCK_NW.state := cbChecked;
  if (CCR2_value and $8 = 0) then
    chkSUSP_HALT.state := cbUnchecked
  else
    chkSUSP_HALT.state := cbChecked;
  if (CCR2_value and $10 = 0) then
    chkWT1.state := cbUnchecked
  else
    chkWT1.state := cbChecked;
  if (CCR2_value and $40 = 0) then
    chkBWRT.state := cbUnchecked
  else
    chkBWRT.state := cbChecked;
  if (CCR2_value and $80 = 0) then
    chkUSE_SUSP.state := cbUnchecked
  else
    chkUSE_SUSP.state := cbChecked;

  if (CCR3_value and $1 = 0) then
    chkSMI_LOCK.state := cbUnchecked
  else
    chkSMI_LOCK.state := cbChecked;
  if (CCR3_value and $2 = 0) then
    chkNMI_EN.state := cbUnchecked
  else
    chkNMI_EN.state := cbChecked;
  if (CCR3_value and $4 = 0) then
    chkLINBRST.state := cbUnchecked
  else
    chkLINBRST.state := cbChecked;
  if (CCR3_value and $8 = 0) then
    chkSMM_MODE.state := cbUnchecked
  else
    chkSMM_MODE.state := cbChecked;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  if (Screen.Width > Width) and (Screen.Height > Height) then
    Self.SetBounds((Screen.Width - Width) shr 1, (Screen.Height - Height) shr 1,
     Width, Height)
  else
    Self.SetBoundS(0, 0, Width, Height);
  Self.Show;
  if isCyrix then begin
    DeviceID := ReadRegister(DIR0);
    if (DeviceID = $29) or (DeviceID = $2B) or (DeviceID = $2D) or
     (DeviceID = $2F) then
      ShowRegisters
    else begin
      Application.MessageBox('Cyrix 5x86 not detected!', 'ERROR', mb_OK);
      Application.Terminate
    end
  end
  else begin
    Application.MessageBox('Cyrix 5x86 not detected!', 'ERROR', mb_OK);
    Application.Terminate
  end
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Self.Close
end;

procedure TfrmMain.btnAdvancedClick(Sender: TObject);
begin
  frmAdvanced.ShowModal
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Self.Close
end;

procedure TfrmMain.About1Click(Sender: TObject);
begin
  frmAboutBox := TfrmAboutBox.Create(Self);
  frmAboutBox.ShowModal
end;

procedure TfrmMain.btnRefreshClick(Sender: TObject);
begin
  ShowRegisters;
  frmAdvanced.ShowRegisters
end;

procedure TfrmMain.btnUpdateClick(Sender: TObject);
begin
  frmMessage := TfrmMessage.Create(Self);
  frmMessage.ShowModal
end;

end.
